## 16 colours palette
PALETTE = 0 1 2 3 6 9 11 12 13 15 16 18 20 24 25 26
PALETTE_GREY_WHITE = 0 1 2 3 6 9 11 12 26 15 16 18 20 24 25 13

## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_FOLDER      , src/               ))
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }
#$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))
#$(eval $(call IMG2SP, CONVERT         , img.png , w, h, array, palette, tileset))
#$(eval $(call IMG2SP, SET_FOLDER, src/sprites/))
#$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites      ))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/     ))
$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)				))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE) 			  , global_palette))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE_GREY_WHITE) , global_palette_gw))

#	SPRITES
$(eval $(call IMG2SP, CONVERT, assets/img/player.png,		    	18, 20, sprt_player))
$(eval $(call IMG2SP, CONVERT, assets/img/fireballs_h.png,			40, 14, sprt_fireballs_h))
$(eval $(call IMG2SP, CONVERT, assets/img/fireballs_h_larger.png, 	70, 14, sprt_fireballs_h_larger))
$(eval $(call IMG2SP, CONVERT, assets/img/fireballs_v.png,  		14, 40, sprt_fireballs_v))
$(eval $(call IMG2SP, CONVERT, assets/img/small_fireball.png,   	10, 10, sprt_small_fireball))
$(eval $(call IMG2SP, CONVERT, assets/img/medium_fireball.png,  	16, 16, sprt_medium_fireball))
$(eval $(call IMG2SP, CONVERT, assets/img/big_fireball.png,  		22, 22, sprt_big_fireball))

$(eval $(call IMG2SP, CONVERT, assets/img/hearts.png, 		12, 9,	spr_hearts))
# $(eval $(call IMG2SP, CONVERT, assets/img/muertes.png, 		12, 11,	spr_dead_counter))
$(eval $(call IMG2SP, CONVERT, assets/img/muertes2.png, 	12, 11,	spr_dead_counter2))
$(eval $(call IMG2SP, CONVERT, assets/img/referencia.png, 	22, 7,	spr_invulnerabality))

#	MESSAGES
$(eval $(call IMG2SP, SET_FOLDER      , src/assets/messages/     ))

$(eval $(call IMG2SP, CONVERT, assets/messages/level.png,  34, 7,	spr_level_message))
$(eval $(call IMG2SP, CONVERT, assets/messages/number1.png, 6, 7,	spr_number1_message))
$(eval $(call IMG2SP, CONVERT, assets/messages/number2.png, 6, 7,	spr_number2_message))
$(eval $(call IMG2SP, CONVERT, assets/messages/number3.png, 6, 7,	spr_number3_message))
$(eval $(call IMG2SP, CONVERT, assets/messages/number4.png, 6, 7,	spr_number4_message))
$(eval $(call IMG2SP, CONVERT, assets/messages/number5.png, 6, 7,	spr_number5_message))

$(eval $(call IMG2SP, CONVERT, assets/messages/win.png,  20, 10,	spr_win_message))
$(eval $(call IMG2SP, CONVERT, assets/messages/dead.png,  72, 21,	spr_dead_message))

$(eval $(call IMG2SP, CONVERT, assets/messages/you_wont_escape.png,  126, 10,	spr_you_wont_escape_message))
$(eval $(call IMG2SP, CONVERT, assets/messages/nooo.png,  44, 8,	spr_nooo_message))

#	TILEMAPS
$(eval $(call IMG2SP, SET_FOLDER      , src/assets/maps/     ))
$(eval $(call IMG2SP, SET_IMG_FORMAT  , zgtiles))
$(eval $(call IMG2SP, CONVERT         , assets/maps/moon_tiles.png 	, 8, 8, t_moon))
$(eval $(call IMG2SP, CONVERT         , assets/maps/planet_tiles.png, 8, 8, t_planet))

#	SCREENS
$(eval $(call IMG2SP, SET_FOLDER,		src/assets/screens/))
$(eval $(call IMG2SP, SET_IMG_FORMAT, 	screen))
$(eval $(call IMG2SP, SET_OUTPUT, 		bin))
$(eval $(call IMG2SP, CONVERT, 			assets/screens/menu.png, 		0, 0, screen_menu))
$(eval $(call IMG2SP, CONVERT, 			assets/screens/controls.png,	0, 0, screen_controls))
$(eval $(call IMG2SP, CONVERT, 			assets/screens/credits.png,		0, 0, screen_credits))