; MIT License

; Copyright (C) 2022 Z80Enjoyers / Luis Jesús Marhuenda Tendero (@ljmt1) / Alberto Vegara Belmonte (@avb52-ua) / Samuel Benjamín Oliva Bulpitt (@samuel0122)

; Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal 
; in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
; copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
; FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
; WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

;;======================================================================================================
;;  Sprite Includes
;;======================================================================================================

;;------------------------------------------------------------------------------------------------------
;; Global Palette
;;
.globl _global_palette
.globl _global_palette_gw

;;------------------------------------------------------------------------------------------------------
;; Player
;;
.globl _sprt_player_00
.globl _sprt_player_01
.globl _sprt_player_02
.globl _sprt_player_03
.globl _sprt_player_04
.globl _sprt_player_05
.globl _sprt_player_06
.globl _sprt_player_07
.globl _sprt_player_08
.globl _sprt_player_09
.globl _sprt_player_10
.globl _sprt_player_11
.globl _sprt_player_12
.globl _sprt_player_13

SPRT_PLAYER_H = 20
SPRT_PLAYER_W = 9
SPRT_PLAYER_H_W = (SPRT_PLAYER_H << 8) + SPRT_PLAYER_W

;;------------------------------------------------------------------------------------------------------
;; Fireballs H
;;
.globl _sprt_fireballs_h_0
.globl _sprt_fireballs_h_1
.globl _sprt_fireballs_h_2
.globl _sprt_fireballs_h_3

SPRT_FIREBALLS_H_H = 14
SPRT_FIREBALLS_H_W = 20
; SPRT_FIREBALLS_H_H_W = (SPRT_FIREBALLS_H_H << 8) + SPRT_FIREBALLS_H_W

;;------------------------------------------------------------------------------------------------------
;; Fireballs V
;;
.globl _sprt_fireballs_v_0
.globl _sprt_fireballs_v_1
.globl _sprt_fireballs_v_2
.globl _sprt_fireballs_v_3

SPRT_FIREBALLS_V_H = 40
SPRT_FIREBALLS_V_W = 7
SPRT_FIREBALLS_V_H_W = (SPRT_FIREBALLS_V_H << 8) + SPRT_FIREBALLS_V_W

;;------------------------------------------------------------------------------------------------------
;; Fireballs H Larger
;;
.globl _sprt_fireballs_h_larger_0
.globl _sprt_fireballs_h_larger_1
.globl _sprt_fireballs_h_larger_2
.globl _sprt_fireballs_h_larger_3

SPRT_FIREBALLS_H_LARGER_0_W = 35
SPRT_FIREBALLS_H_LARGER_0_H = 14


;;------------------------------------------------------------------------------------------------------
;; Small Fireball
;;
.globl _sprt_small_fireball_0
.globl _sprt_small_fireball_1
.globl _sprt_small_fireball_2
.globl _sprt_small_fireball_3

SPRT_SMALL_FIREBALL_H = 10
SPRT_SMALL_FIREBALL_W = 5
sprt_SMALL_FIREBALL_H_W = (SPRT_SMALL_FIREBALL_H + 8) + SPRT_SMALL_FIREBALL_W

;;------------------------------------------------------------------------------------------------------
;; Medium Fireball
;;
.globl _sprt_medium_fireball_0
.globl _sprt_medium_fireball_1
.globl _sprt_medium_fireball_2
.globl _sprt_medium_fireball_3

SPRT_MEDIUM_FIREBALL_H = 16
SPRT_MEDIUM_FIREBALL_W = 8
sprt_MEDIUM_FIREBALL_H_W = (SPRT_MEDIUM_FIREBALL_H + 8) + SPRT_MEDIUM_FIREBALL_W

;;------------------------------------------------------------------------------------------------------
;; Big Fireball
;;
.globl _sprt_big_fireball_0
.globl _sprt_big_fireball_1
.globl _sprt_big_fireball_2
.globl _sprt_big_fireball_3

SPRT_BIG_FIREBALL_H = 22
SPRT_BIG_FIREBALL_W = 11
sprt_BIG_FIREBALL_H_W = (SPRT_BIG_FIREBALL_H + 8) + SPRT_BIG_FIREBALL_W



;;------------------------------------------------------------------------------------------------------
;; Level message
;;
.globl _spr_level_message_0
.globl _spr_level_message_1
.globl _spr_level_message_2
.globl _spr_level_message_3
.globl _spr_level_message_4
.globl _spr_level_message_5
.globl _spr_level_message_6
SPR_LEVEL_MESSAGE_W = 17
SPR_LEVEL_MESSAGE_H =  7


;;------------------------------------------------------------------------------------------------------
;; Numbers
;;

SPR_NUMBER_MESSAGE_W = 3
SPR_NUMBER_MESSAGE_H =  7

;;
;; Number 1
;;
.globl _spr_number1_message_0
.globl _spr_number1_message_1

;;
;; Number 2
;;
.globl _spr_number2_message_0
.globl _spr_number2_message_1

;;
;; Number 3
;;
.globl _spr_number3_message_0
.globl _spr_number3_message_1

;;
;; Number 4
;;
.globl _spr_number4_message_0
.globl _spr_number4_message_1

;;
;; Number 5
;;
.globl _spr_number5_message_0
.globl _spr_number5_message_1


;;------------------------------------------------------------------------------------------------------
;; Hearths
;;
.globl _spr_hearts_0
.globl _spr_hearts_1


SPR_HEARTS_W = 6
SPR_HEARTS_H = 9


;;------------------------------------------------------------------------------------------------------
;; Dead Counter
;;
SPR_DEAD_COUNTER_W = 6
SPR_DEAD_COUNTER_H = 11
.globl _spr_dead_counter2


;;------------------------------------------------------------------------------------------------------
;; Invulnerabitly Symbol
;;
SPR_INVULNERABALITY_W = 11
SPR_INVULNERABALITY_H = 7
.globl _spr_invulnerabality


;;------------------------------------------------------------------------------------------------------
;; Win
;;
.globl _spr_win_message


SPR_WIN_W = 10
SPR_WIN_H = 10

;;------------------------------------------------------------------------------------------------------
;; Dead
;;
.globl _spr_dead_message

SPR_DEAD_W = 36
SPR_DEAD_H = 21


;;------------------------------------------------------------------------------------------------------
;; You wont escape
;;
.globl _spr_you_wont_escape_message_0
.globl _spr_you_wont_escape_message_1

SPR_YOU_WONT_ESCAPE_W = 63
SPR_YOU_WONT_ESCAPE_H = 10

;;------------------------------------------------------------------------------------------------------
;; You wont escape
;;
.globl _spr_nooo_message_0
.globl _spr_nooo_message_1

SPR_NOOO_W = 22
SPR_NOOO_H = 8

;;------------------------------------------------------------------------------------------------------
;; Planets
;;
.globl _sprt_planets_0 ; Red
.globl _sprt_planets_1 ; Blue
.globl _sprt_planets_2 ; Green

SPRT_PLANET_W = 14
SPRT_PLANET_H = 26