; MIT License

; Copyright (C) 2022 Z80Enjoyers / Luis Jesús Marhuenda Tendero (@ljmt1) / Alberto Vegara Belmonte (@avb52-ua) / Samuel Benjamín Oliva Bulpitt (@samuel0122)

; Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal 
; in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
; copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
; FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
; WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

;;======================================================================================================
;;  CPCtelera functions
;;======================================================================================================
    
    SCREEN_BOTTOM_BOUND     = 176
    SCREEN_TOP_BOUND        = 40
    SCREEN_WITDH            = 80

;;------------------------------------------------------------------------------------------------------
;; Firmware
;;
.globl cpct_disableFirmware_asm

;;------------------------------------------------------------------------------------------------------
;; Video
;;
.globl cpct_setVideoMode_asm
.globl cpct_setPALColour_asm
.globl cpct_setPalette_asm
.globl cpct_setVideoMode_asm
.globl cpct_getScreenPtr_asm
.globl cpct_drawStringM0_asm
.globl cpct_setDrawCharM0_asm
.globl cpct_drawCharM0_asm

;;------------------------------------------------------------------------------------------------------
;; Sprites
;;
.globl cpct_drawSprite_asm
.globl cpct_drawSolidBox_asm
.globl cpct_drawSpriteMaskedAlignedTable_asm
.globl cpct_drawSpriteBlended_asm
.globl cpct_drawSpriteMasked_asm

;;------------------------------------------------------------------------------------------------------
;; Memory
;;
.globl cpct_memset_asm
.globl cpct_memcpy_asm

;;------------------------------------------------------------------------------------------------------
;; Easytilemaps
;;
.globl cpct_etm_setDrawTilemap4x8_ag_asm
.globl cpct_etm_drawTilemap4x8_ag_asm

;;------------------------------------------------------------------------------------------------------
;; Keyboard
;;
.globl cpct_scanKeyboard_f_asm
.globl cpct_isKeyPressed_asm
.globl cpct_isAnyKeyPressed_asm
.globl cpct_waitVSYNC_asm
.globl cpct_waitVSYNCStart_asm

;;------------------------------------------------------------------------------------------------------
;; Random
;;
.globl cpct_getRandom_mxor_u8_asm

;;------------------------------------------------------------------------------------------------------
;; Strings
;;
.globl cpct_drawStringM0_asm
.globl cpct_setDrawCharM0_asm
.globl cpct_drawCharM0_asm

;;------------------------------------------------------------------------------------------------------
;; Compression
;;
.globl cpct_zx7b_decrunch_s_asm

;;------------------------------------------------------------------------------------------------------
;; Music
;;
.globl cpct_akp_musicInit_asm
.globl cpct_akp_musicPlay_asm
.globl cpct_akp_stop_asm