; MIT License

; Copyright (C) 2022 Z80Enjoyers / Luis Jesús Marhuenda Tendero (@ljmt1) / Alberto Vegara Belmonte (@avb52-ua) / Samuel Benjamín Oliva Bulpitt (@samuel0122)

; Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal 
; in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
; copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
; FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
; WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

;;======================================================================================================
;;  Entity Manager Includes
;;======================================================================================================

;;------------------------------------------------------------------------------------------------------
;; Private Constants
;;

;;------------------------------------------------------------------------------------------------------
;; Private Interface
;;

;;------------------------------------------------------------------------------------------------------
;; Public Constants
;;

;;------------------------------------------------------------------------------------------------------
;; Public Functions (Global Symbols)
;;
.globl man_entity_create
.globl man_entity_forall_matching
.globl man_entity_destroy
.globl man_entity_freeSpace
.globl man_entity_set4destroy
.globl man_entity_update
.globl man_entity_forall_pairs_matching
.globl man_entity_lose_life
.globl man_entity_erase_all
.globl man_entity_increase_life
.globl man_entity_decrement_collding_counter

;;------------------------------------------------------------------------------------------------------
;; Public Values (Global Symbols)
;;
.globl entities
.globl m_num_created_entities
.globl m_next_free_entity

;;------------------------------------------------------------------------------------------------------
;; Defined Values for Player and Enemies
;;
    e_type                          = 0
    e_cmps                          = 1
    e_x                             = 2
    e_y                             = 3
    e_w                             = 4
    e_h                             = 5
    e_vx                            = 6
    e_vy                            = 7
    e_sprite                        = 8  ; 8 and 9 byte ; THIS FILL TWO BYTES, SO THE NEXT VALUE WILL BE IN 10
    e_collides_against              = 10
    e_colliding_counter             = 11 ; time to wait until check again if it is colliding
    e_lifes                         = 12 ; Lifes of the character, for now it will have two lifes
    e_animations                    = 13 ; 13 and 14 bytes
    e_anim_count                    = 15 ; 15
    e_anim_status                   = 16
    e_behaviour_func                = 17 ; 17 and 18 
    e_behaviour_count               = 19 ; 19 
    e_prev_pointer                  = 20 ; 20 and 21

    max_entities                    = 6
    sizeof_e                        = 22

;;------------------------------------------------------------------------------------------------------
;; Defined Entity Types
;;
    e_type_invalid       = 0x00
    e_type_player        = 0x01
    e_type_enemy         = 0x02
    e_type_dead          = 0x40
    e_type_alive         = 0x80

;;------------------------------------------------------------------------------------------------------
;; Defined Entity Types Componets
;;
    e_cmp_invalid        = 0x00
    e_cmp_render         = 0x01
    e_cmp_physics        = 0x02
    e_cmp_input          = 0x04
    e_cmp_collider       = 0x08
    e_cmp_generator      = 0x10
    e_cmp_animated       = 0x20
    e_cmp_ai             = 0x40
    e_cmp_extra_life     = 0x80
    e_cmp_all            = 0xFF

;;------------------------------------------------------------------------------------------------------
;; Initial entities values
;;
    PLAYER_SPEED_INIT           = 1
    ENEMY_SPEED_INIT            = -1
    ; WAITING_TIME_TO_MOVE_PLANET = 10
