; MIT License

; Copyright (C) 2022 Z80Enjoyers / Luis Jesús Marhuenda Tendero (@ljmt1) / Alberto Vegara Belmonte (@avb52-ua) / Samuel Benjamín Oliva Bulpitt (@samuel0122)

; Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal 
; in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
; copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
; FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
; WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

;;======================================================================================================
.module Score_Manager
;;======================================================================================================
.area _CODE
;;======================================================================================================
.include "man/score.h.s"
.include "sys/render.h.s"
;;======================================================================================================

;;======================================================================================================
;; Public Values
distance_score::
    .db 0, 0

;======================================================================================================
;   Manages Game memory before starting a new game
;   
;   Inputs:
;       -
;   Outputs:
;       -
;
man_score_print_lifes_and_distance::
    call sys_render_show_dead_counter
    call sys_render_show_lifes
    call sys_render_show_distance_score
    call man_score_increment_distance_score_by_1

    ret

;======================================================================================================
;  Manages Game memory before starting a new game
;
man_score_increment_distance_score_by_1::
    ld hl, (distance_score)

    ld a, l
    add #0x01
    daa
    ld l, a
    ld a, h
    adc #0x0
    daa
    ld h, a

    ld (distance_score), hl

    ret

;======================================================================================================
;  Manages Game memory before starting a new game
;
man_score_reset_score::
    ld  hl, #0x00
    ld (distance_score), hl

    ret